using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using static Exferia_Aplicacion.General.Enumerados;
using Exferia_General._1_Datos;
using System.Transactions;
using System.Data.SqlClient;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_Partes_ProtocolosRellenos_Datos 
    {
        #region Obtener

        public List<MYT_Partes_ProtocolosRellenos> Obtener(long _lng_idParte,long _lng_idProtocolo)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<MYT_Partes_ProtocolosRellenos> lst_MYT_Partes_ProtocolosRellenos_Obtener = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.id) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.numero) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idTecnico) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idTerminal) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaHora) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.tipo) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocoloPregunta) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocoloRespuesta) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.respuesta) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.observaciones) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.guid) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) +
                        " FROM " + nameof(MYT_Partes_ProtocolosRellenos) +
                        " WHERE  " + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + " IS null AND " +
                                     nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte and " +
                                     nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + "=@idProtocolo ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idParte",  _lng_idParte),
                     new SqlParameter("@idProtocolo",  _lng_idProtocolo)
                };

                //Rellenar el Listado
                lst_MYT_Partes_ProtocolosRellenos_Obtener = obj_Exferia_Entities.Database.SqlQuery<MYT_Partes_ProtocolosRellenos>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MYT_Partes_ProtocolosRellenos_Obtener;
        }

        public List<MYT_Partes_ProtocolosRellenos> Obtener_Para_Impresion_Por_Instalacion(int _int_Cantidad_A_Sacar, long _lng_idParte,long _lng_idCliente, long _lng_idInstalacionCabecera, long? _lng_idInstalacionLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<MYT_Partes_ProtocolosRellenos> lst_MYT_Partes_ProtocolosRellenos = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                          " SELECT " + 
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.id) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.numero) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idTecnico) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idTerminal) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaHora) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.tipo) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocoloPregunta) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocoloRespuesta) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.respuesta) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.observaciones) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.guid) + " , " +
                                nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) +
                        " FROM " + nameof(MYT_Partes_ProtocolosRellenos) +
                        " INNER JOIN " + 
                            " ( " + 
                                " SELECT TOP " + _int_Cantidad_A_Sacar + " " + 
                                    nameof(MYT_Partes) + "." + nameof(MYT_Partes.id) + "," +
                                    nameof(MYT_Partes) + "." + nameof(MYT_Partes.idInstalacionCabecera) +
                                " FROM " + nameof(MYT_Partes) +
                                " WHERE " +
                                     nameof(MYT_Partes) + "." + nameof(MYT_Partes.id) + "<>@idParte and " +
                                     nameof(MYT_Partes) + "." + nameof(MYT_Partes.fechaBorrado) + " IS null AND " +
                                     nameof(MYT_Partes) + "." + nameof(MYT_Partes.idInstalacionCabecera) + "=@idInstalacionCabecera   " +
                                    (_lng_idInstalacionLinea != null ? " and " + nameof(MYT_Partes) + "." + nameof(MYT_Partes.idInstalacionLinea) + "=@idInstalacionLinea " : "") +
                            " ) as PARTES ON " + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + " = PARTES." + nameof(MYT_Partes.id) +
                        " INNER JOIN " + nameof(MYT_InstalacionesCabecera) + " ON PARTES." + nameof(MYT_Partes.idInstalacionCabecera) + " = " + nameof(MYT_InstalacionesCabecera) + "." + nameof(MYT_InstalacionesCabecera.id) +
                        " WHERE  " + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + " IS null AND " +
                                     nameof(MYT_InstalacionesCabecera) + "." + nameof(MYT_InstalacionesCabecera.idCliente) + "=@idCliente " +   
                        " ORDER BY " + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaHora) + " DESC," + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.id) + " ASC "; 

                //Parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@idParte", _lng_idParte));
                lst_Parametros.Add(new SqlParameter("@idCliente", _lng_idCliente));
                lst_Parametros.Add(new SqlParameter("@idInstalacionCabecera", _lng_idInstalacionCabecera));
                if (_lng_idInstalacionLinea != null)
                {
                    lst_Parametros.Add(new SqlParameter("@idInstalacionLinea", _lng_idInstalacionLinea.Value));
                }

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Listado
                lst_MYT_Partes_ProtocolosRellenos = obj_Exferia_Entities.Database.SqlQuery<MYT_Partes_ProtocolosRellenos>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener_Para_Impresion_Por_Instalacion), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MYT_Partes_ProtocolosRellenos;
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private MYT_Partes_ProtocolosRellenos g_mdl_MYT_Partes_ProtocolosRellenos = null;

        public MYT_Partes_ProtocolosRellenos Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MYT_Partes_ProtocolosRellenos;
        }
        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MYT_Partes_ProtocolosRellenos = obj_Exferia_Entities.Database.SqlQuery<MYT_Partes_ProtocolosRellenos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion
        #endregion

        #region Modelo Listado
        private List<MYT_Partes_ProtocolosRellenos> g_lst_MYT_Partes_ProtocolosRellenos = null;

        public List<MYT_Partes_ProtocolosRellenos> Obtener_ModeloListado_Por_IdParte(long _lng_idParte)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + 
                                       nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte and " +
                                       nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + " is null ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idParte",  _lng_idParte)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdParte), true);
            }

            return g_lst_MYT_Partes_ProtocolosRellenos;
        }
        public List<MYT_Partes_ProtocolosRellenos> Obtener_ModeloListado_Por_IdParteIdProtocolo(long _lng_idParte,long _lng_idProtocolo)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " +
                                       nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte and " +
                                       nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + "=@idProtocolo and " +
                                       nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + " is null ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idParte",  _lng_idParte),
                     new SqlParameter("@idProtocolo",  _lng_idProtocolo)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdParteIdProtocolo), true);
            }

            return g_lst_MYT_Partes_ProtocolosRellenos;
        }
        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MYT_Partes_ProtocolosRellenos = obj_Exferia_Entities.Database.SqlQuery<MYT_Partes_ProtocolosRellenos>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(MYT_Partes_ProtocolosRellenos.id) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.idParte) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.numero) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.idTecnico) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.idTerminal) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.fechaHora) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.tipo) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.idProtocoloPregunta) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.idProtocoloRespuesta) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.respuesta) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.observaciones) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.guid) + "," +
                    nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + 
                " FROM " + nameof(MYT_Partes_ProtocolosRellenos);
        }
        #endregion

        #region Para Listado

        #region Simple
        private INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo g_mdl_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO = null;
        public INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo Obtener_Registro_Para_Listado_Por_IdParteIdProtocolo(long _lng_idParte,long _lng_idProtocolo)
        {

            g_mdl_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO = null;

            try
            {
                string str_SQL = Obtener_Consulta_Para_Listado() +
                                " WHERE " +
                                    nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + "  is null AND " +
                                    nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + " =@idParte and " +
                                    nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + " =@idProtocolo ";
                //where
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@idParte", _lng_idParte));
                lst_Parametros.Add(new SqlParameter("@idProtocolo", _lng_idProtocolo));

                //Parametros
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar
                Ejecutar_Consulta_Modelo_ParaListado(str_SQL, arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener_Registro_Para_Listado_Por_IdParteIdProtocolo), true);
            }

            return g_mdl_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO;
        }

        #region Ejecutar Consulta Modelo Para Listado

        private void Ejecutar_Consulta_Modelo_ParaListado(string _str_SQL,
                                                            object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_ParaListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        #region Listado
        private List<INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo> g_lst_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO = null;

        public List<INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo> Obtener_Registros_Para_Listado_Por_Parte(long _lng_idParte)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Para_Listado() +
                                    " WHERE " +
                                        nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + " is null and " +
                                        nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte ";
               
                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@idParte",  _lng_idParte)
                };

                Ejecutar_Consulta_Modelo_Listado_PARALISTADO(str_SQL,
                                                            arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_Parte), true);
            }

            return g_lst_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO;
        }
        public List<dynamic> Obtener_Registros_Para_Listado_Por_Ids(long _lng_idParte,List<long> _lst_idProtocolos)
        {
            List<dynamic> lst_Listado = null;

            try
            {

                if (_lst_idProtocolos != null && _lst_idProtocolos.Count > 0)
                {
                    string str_Filtro_Protocolos = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MYT_Partes_ProtocolosRellenos),
                                                                                                     nameof(MYT_Partes_ProtocolosRellenos.idProtocolo),
                                                                                                     G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                                     _lst_idProtocolos);

                    string str_SQL = Obtener_Consulta_Para_Listado() +
                                        " WHERE " +
                                            nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + " is null and " +
                                            nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte and " +
                                            str_Filtro_Protocolos;
                    //Parametros
                    object[] arr_Parametros = new object[]
                    {
                    new SqlParameter("@idParte",  _lng_idParte)
                    };

                    Ejecutar_Consulta_Modelo_Listado_PARALISTADO(str_SQL,
                                                                 arr_Parametros);


                    //Si no es nulo, lo transformo a Dinamico
                    if (g_lst_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO != null && g_lst_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO.Count > 0)
                    {
                        lst_Listado = g_lst_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO.Cast<dynamic>().ToList();
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_Ids), true);
            }

            return lst_Listado;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado_PARALISTADO(string _str_SQL,
                                                                 object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_lst_INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo_PARALISTADO = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado_PARALISTADO), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Para_Listado()
        {
            return
                  " SELECT distinct " +
                        //Protocolo
                        nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo_Id) + "=" + nameof(MYT_Protocolos) + "." + nameof(MYT_Protocolos.id) + "," +
                        nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo_Codigo) + "=" + nameof(MYT_Protocolos) + "." + nameof(MYT_Protocolos.codigo) + "," +
                        nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo_Descripcion) + "=" + nameof(MYT_Protocolos) + "." + nameof(MYT_Protocolos.descripcion) + "," +
                        nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo_FechaBorrado) + "=" + nameof(MYT_Protocolos) + "." + nameof(MYT_Protocolos.fechaBorrado) + "," +
                        //Tipo
                        nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Tipo) + "=" + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.tipo) + 
                    " FROM " + nameof(MYT_Partes_ProtocolosRellenos) +
                    " INNER JOIN " + nameof(MYT_Protocolos) + " ON " + nameof(MYT_Partes_ProtocolosRellenos) + "." + nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + " = " + nameof(MYT_Protocolos) + "." + nameof(MYT_Protocolos.id);
        }

        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Grabar(MYT_Partes_ProtocolosRellenos _mdl_MYT_Partes_ProtocolosRellenos)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_Partes_ProtocolosRellenos mdl_MYT_Partes_ProtocolosRellenos_DatosViejos = new MYT_Partes_ProtocolosRellenos();

                // Ver si existe ######################################################################
                MYT_Partes_ProtocolosRellenos mdl_MYT_Partes_ProtocolosRellenos_Final = Obtener_Modelo_Por_Id(_mdl_MYT_Partes_ProtocolosRellenos.id);
                //######################################################################################

                //UPDATE
                if (mdl_MYT_Partes_ProtocolosRellenos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_Partes_ProtocolosRellenos_Final, mdl_MYT_Partes_ProtocolosRellenos_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(_mdl_MYT_Partes_ProtocolosRellenos, mdl_MYT_Partes_ProtocolosRellenos_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_Partes_ProtocolosRellenos) +
                                           " SET " +
                                                nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte," +
                                                nameof(MYT_Partes_ProtocolosRellenos.numero) + "=@numero," +
                                                nameof(MYT_Partes_ProtocolosRellenos.idTecnico) + "=@idTecnico," +
                                                nameof(MYT_Partes_ProtocolosRellenos.idTerminal) + "=@idTerminal," +
                                                nameof(MYT_Partes_ProtocolosRellenos.fechaHora) + "=@fechaHora," +
                                                nameof(MYT_Partes_ProtocolosRellenos.tipo) + "=@tipo," +
                                                nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + "=@idProtocolo," +
                                                nameof(MYT_Partes_ProtocolosRellenos.idProtocoloPregunta) + "=@idProtocoloPregunta," +
                                                nameof(MYT_Partes_ProtocolosRellenos.idProtocoloRespuesta) + "=@idProtocoloRespuesta," +
                                                nameof(MYT_Partes_ProtocolosRellenos.respuesta) + "=@respuesta," +
                                                nameof(MYT_Partes_ProtocolosRellenos.observaciones) + "=@observaciones," +
                                                nameof(MYT_Partes_ProtocolosRellenos.guid) + "=@guid," +
                                                nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + "=@fechaBorrado " +
                                           " WHERE " +
                                               nameof(MYT_Partes_ProtocolosRellenos.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@idParte",  mdl_MYT_Partes_ProtocolosRellenos_Final.idParte),
                         new SqlParameter("@numero",  mdl_MYT_Partes_ProtocolosRellenos_Final.numero),
                         mdl_MYT_Partes_ProtocolosRellenos_Final.idTecnico!=null
                            ?   new SqlParameter("@idTecnico", mdl_MYT_Partes_ProtocolosRellenos_Final.idTecnico.Value)
                            :   new SqlParameter("@idTecnico",  DBNull.Value),
                         mdl_MYT_Partes_ProtocolosRellenos_Final.idTerminal!=null
                            ?   new SqlParameter("@idTerminal", mdl_MYT_Partes_ProtocolosRellenos_Final.idTerminal.Value)
                            :   new SqlParameter("@idTerminal",  DBNull.Value),
                         new SqlParameter("@fechaHora",  mdl_MYT_Partes_ProtocolosRellenos_Final.fechaHora),
                         new SqlParameter("@tipo",  mdl_MYT_Partes_ProtocolosRellenos_Final.tipo),
                         new SqlParameter("@idProtocolo",  mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocolo),
                         new SqlParameter("@idProtocoloPregunta",  mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocoloPregunta),
                         mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocoloRespuesta!=null
                            ?   new SqlParameter("@idProtocoloRespuesta", mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocoloRespuesta.Value)
                            :   new SqlParameter("@idProtocoloRespuesta",  DBNull.Value),
                         mdl_MYT_Partes_ProtocolosRellenos_Final.respuesta!=null
                            ?   new SqlParameter("@respuesta", mdl_MYT_Partes_ProtocolosRellenos_Final.respuesta)
                            :   new SqlParameter("@respuesta",  DBNull.Value),
                         mdl_MYT_Partes_ProtocolosRellenos_Final.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_MYT_Partes_ProtocolosRellenos_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                         mdl_MYT_Partes_ProtocolosRellenos_Final.guid!=null
                            ?   new SqlParameter("@guid", mdl_MYT_Partes_ProtocolosRellenos_Final.guid)
                            :   new SqlParameter("@guid",  DBNull.Value),
                         mdl_MYT_Partes_ProtocolosRellenos_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_Partes_ProtocolosRellenos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         new SqlParameter("@id",  mdl_MYT_Partes_ProtocolosRellenos_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MYT_Partes_ProtocolosRellenos_Final.id;
                }
                //INSERT
                else
                {
                    mdl_MYT_Partes_ProtocolosRellenos_Final = new MYT_Partes_ProtocolosRellenos();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(_mdl_MYT_Partes_ProtocolosRellenos, mdl_MYT_Partes_ProtocolosRellenos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MYT_Partes_ProtocolosRellenos) +
                                              " (" +
                                                    nameof(MYT_Partes_ProtocolosRellenos.idParte) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.numero) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.idTecnico) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.idTerminal) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.fechaHora) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.tipo) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.idProtocoloPregunta) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.idProtocoloRespuesta) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.respuesta) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.observaciones) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.guid) + "," +
                                                    nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(MYT_Partes_ProtocolosRellenos.id) +
                                              " VALUES " +
                                              " ( " +
                                                    "@idParte," +
                                                    "@numero," +
                                                    "@idTecnico," +
                                                    "@idTerminal," +
                                                    "@fechaHora," +
                                                    "@tipo," +
                                                    "@idProtocolo," +
                                                    "@idProtocoloPregunta," +
                                                    "@idProtocoloRespuesta," +
                                                    "@respuesta," +
                                                    "@observaciones," +
                                                    "@guid," +
                                                    "@fechaBorrado" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idParte",  mdl_MYT_Partes_ProtocolosRellenos_Final.idParte),
                        new SqlParameter("@numero",  mdl_MYT_Partes_ProtocolosRellenos_Final.numero),
                        mdl_MYT_Partes_ProtocolosRellenos_Final.idTecnico!=null
                            ?   new SqlParameter("@idTecnico", mdl_MYT_Partes_ProtocolosRellenos_Final.idTecnico.Value)
                            :   new SqlParameter("@idTecnico",  DBNull.Value),
                        mdl_MYT_Partes_ProtocolosRellenos_Final.idTerminal!=null
                            ?   new SqlParameter("@idTerminal", mdl_MYT_Partes_ProtocolosRellenos_Final.idTerminal.Value)
                            :   new SqlParameter("@idTerminal",  DBNull.Value),
                        new SqlParameter("@fechaHora",  mdl_MYT_Partes_ProtocolosRellenos_Final.fechaHora),
                        new SqlParameter("@tipo",  mdl_MYT_Partes_ProtocolosRellenos_Final.tipo),
                        new SqlParameter("@idProtocolo",  mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocolo),
                        new SqlParameter("@idProtocoloPregunta",  mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocoloPregunta),
                        mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocoloRespuesta!=null
                            ?   new SqlParameter("@idProtocoloRespuesta", mdl_MYT_Partes_ProtocolosRellenos_Final.idProtocoloRespuesta.Value)
                            :   new SqlParameter("@idProtocoloRespuesta",  DBNull.Value),
                        mdl_MYT_Partes_ProtocolosRellenos_Final.respuesta!=null
                            ?   new SqlParameter("@respuesta", mdl_MYT_Partes_ProtocolosRellenos_Final.respuesta)
                            :   new SqlParameter("@respuesta",  DBNull.Value),
                        mdl_MYT_Partes_ProtocolosRellenos_Final.observaciones!=null
                            ?   new SqlParameter("@observaciones", mdl_MYT_Partes_ProtocolosRellenos_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                        mdl_MYT_Partes_ProtocolosRellenos_Final.guid!=null
                            ?   new SqlParameter("@guid", mdl_MYT_Partes_ProtocolosRellenos_Final.guid)
                            :   new SqlParameter("@guid",  DBNull.Value),
                        mdl_MYT_Partes_ProtocolosRellenos_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_Partes_ProtocolosRellenos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_Partes_ProtocolosRellenos), mdl_MYT_Partes_ProtocolosRellenos_DatosViejos, mdl_MYT_Partes_ProtocolosRellenos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(MYT_Partes_ProtocolosRellenos) +
                                            " SET " +
                                            nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + "=@fechaBorrado " +
                                        " WHERE " +
                                            nameof(MYT_Partes_ProtocolosRellenos.id) + "=@id ";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Borrar_Por_Parte_Protocolo), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Borrar_Por_Parte_Protocolo(long _lng_idParte,long _lng_idProtocolo)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(MYT_Partes_ProtocolosRellenos) +
                                            " SET " +
                                            nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + "=@fechaBorrado " +
                                        " WHERE " +
                                            nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + "=@idProtocolo and " +
                                            nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@idProtocolo", _lng_idProtocolo),
                        new SqlParameter("@idParte", _lng_idParte)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_idProtocolo;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Borrar_Por_Parte_Protocolo), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_idParte, List<long> _lst_idProtocolo)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                if (_lst_idProtocolo != null && _lst_idProtocolo.Count > 0)
                {
                    string str_Filtro_Protocolos = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idProtocolo);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_Partes_ProtocolosRellenos) +
                                                " SET " +
                                                nameof(MYT_Partes_ProtocolosRellenos.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MYT_Partes_ProtocolosRellenos.idParte) + "=@idParte and " +
                                                nameof(MYT_Partes_ProtocolosRellenos.idProtocolo) + " in (" + str_Filtro_Protocolos + ")";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@idParte", _lng_idParte)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Partes_ProtocolosRellenos_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
